<?php
/**
 * Created by PhpStorm.
 * @author mihovil.bubnjar
 * @date 18.08.2016
 * @time 13:42
 */

#namespace SicoCreditPlus\Controllers\Backend;

class Shopware_Controllers_Backend_SicoCreditPlusOfferedOptions extends Shopware_Controllers_Backend_Application {
	protected $model = 'SicoCreditPlus\\Models\\OfferedOption\\OfferedOption';
	protected $alias = 'sicoofferedoption';

	public function getList( $iOffset, $iLimit, $aSort = array(), $aFilter = array(), array $aWholeParams = array() ) {
		$aReturn = parent::getList($iOffset, $iLimit, $aSort, $aFilter, $aWholeParams );
		// Füge "name" zum Model "productgroup" hinzu. 
		if ( $aReturn && $aReturn['data'] ) {
			foreach ( $aReturn['data'] as $iKey => $aData ) {
				if ( $aData['productgroup'] ) {
					$aData['productgroup']['name'] = $aData['productgroup']['sicoName'];
					$aReturn['data'][$iKey] = $aData;
				}
			}
		}

		return $aReturn;
	}

	protected function getListQuery()
	{
		$builder = parent::getListQuery();

		$builder->leftJoin('sicoofferedoption.productgroup', 'sicoproductgroup');
		$builder->addSelect(array('sicoproductgroup'));

		return $builder;
	}

	protected function getDetailQuery($id)
	{
		$builder = parent::getDetailQuery($id);

		$builder->leftJoin('sicoofferedoption.productgroup', 'sicoproductgroup');
		$builder->addSelect(array('sicoproductgroup'));

		return $builder;
	}

	/**
	 * @param string $sSearch
	 * @param string $sAssociation
	 * @param int $iOffset
	 * @param int $iLimit
	 * @param null $iId
	 * @param array $filter
	 * @param array $sort
	 *
	 * @return array
	 */
	public function searchAssociation($sSearch, $sAssociation, $iOffset, $iLimit, $iId = null, $filter = [], $sort = []) {
		if(empty($sSearch)){
			$sSearch = '';
		}
		$aReturn = parent::searchAssociation($sSearch, $sAssociation, $iOffset, $iLimit, $iId,$filter,$sort);
		if ( $sAssociation == 'productgroup' ) {
			if ( $aReturn['data'] ) {
				foreach ( $aReturn['data'] as $iKey => $aData ) {
					$aData['name'] = $aData['sicoName'];
					$aReturn['data'][$iKey] = $aData;
				}
			}
		}
		return $aReturn;
	}

	/**
	 * @param int $iID
	 * @return array
	 */
	public function delete($iID) {
		if ( $iID === null ) {
			$oRep = $this->getRepository();
			$oReq = $this->Request();
			$aResults = $oRep->findBy(array(
				'sicoActive' => $oReq->getParam('sicoActive'),
				'sicoInterest' => $oReq->getParam('sicoInterest'),
				'sicoMonths' => $oReq->getParam('sicoMonths'),
				'sicoProdcode' => $oReq->getParam('sicoProdcode'),
				'sicoProdgroup' => $oReq->getParam('sicoProdgroup'),
				'sicoRatefactor' => $oReq->getParam('sicoRatefactor')
			), array(
				'id' => 'DESC'
			));
			if ( $aResults ) {
				/** @var \SicoCreditPlus\Models\OfferedOption\OfferedOption $oResult */
				$oResult = $aResults[0];
				$iID = $oResult->getId();
			}
		}
		return parent::delete($iID);
	}

	/**
	 * @return \SicoCreditPlus\Models\OfferedOption\Repository
	 */
	protected function getRepository() {
		return parent::getRepository();
	}
}
