<?php
/**
 * Created by PhpStorm.
 * @author mihovil.bubnjar
 * @date 09.08.2016
 * @time 15:15
 */

namespace SicoCreditPlus\Models\CreditPlusPayment;


use Shopware\Components\Model\ModelEntity;
use Doctrine\ORM\Mapping as ORM;
use Shopware\Models\Order\Order;

/**
 * @ORM\Entity(repositoryClass="Repository")
 * @ORM\Table(name="sico_credit_plus_payment")
 */
class CreditPlusPayment extends ModelEntity {

	/**
	 * @var int
	 *
	 * @ORM\Column(name="id", type="integer", nullable=false)
	 * @ORM\Id
	 * @ORM\GeneratedValue(strategy="IDENTITY")
	 */
	private $id = NULL;
	/**
	 * @var int
	 *
	 * @ORM\Column(name="sico_order_id", type="integer")
	 */
	private $sicoOrderId = 0;
	/**
	 * @var string
	 *
	 * @ORM\Column(name="sico_order_link", type="string")
	 */
	private $sicoOrderLink = '';
	/**
	 * @var string
	 *
	 * @ORM\Column(name="sico_order_finish", type="string")
	 */
	private $sicoOrderFinish = '';
	/**
	 * @var int
	 *
	 * @ORM\Column(name="sico_linkgen_timestamp", type="integer")
	 */
	private $sicoLinkgenTimestamp = 0;


	/**
	 * @return int
	 */
	public function getId() {
		return $this->id;
	}

	/**
	 * @return int
	 */
	public function getSicoOrderId() {
		return $this->sicoOrderId;
	}

	/**
	 * @param int $sicoOrderId
	 */
	public function setSicoOrderId( $sicoOrderId ) {
		$this->sicoOrderId = $sicoOrderId;
	}

	/**
	 * @return string
	 */
	public function getSicoOrderLink() {
		return $this->sicoOrderLink;
	}

	/**
	 * @param string $sicoOrderLink
	 */
	public function setSicoOrderLink( $sicoOrderLink ) {
		$this->sicoOrderLink = $sicoOrderLink;
	}

	/**
	 * @return string
	 */
	public function getSicoOrderFinish() {
		return $this->sicoOrderFinish;
	}

	/**
	 * @param string $sicoOrderFinish
	 */
	public function setSicoOrderFinish( $sicoOrderFinish ) {
		$this->sicoOrderFinish = $sicoOrderFinish;
	}

	/**
	 * @return int
	 */
	public function getSicoLinkgenTimestamp() {
		return $this->sicoLinkgenTimestamp;
	}

	/**
	 * @param int $sicoLinkgenTimestamp
	 */
	public function setSicoLinkgenTimestamp( $sicoLinkgenTimestamp ) {
		$this->sicoLinkgenTimestamp = $sicoLinkgenTimestamp;
	}







	/**
	 * OWNING SIDE
	 *
	 * @var Order
	 *
	 * @ORM\ManyToOne(targetEntity="Shopware\Models\Order\Order")
	 * @ORM\JoinColumn(name="sico_order_id", referencedColumnName="id")
	 */
	private $order = NULL;

	/**
	 * @return Order
	 */
	public function getOrder() {
		return $this->order;
	}

	/**
	 * @param Order $order
	 */
	public function setOrder( $order ) {
		$this->order = $order;
	}

}