<?php
/**
 * Created by PhpStorm.
 * @author mihovil.bubnjar
 * @date 09.08.2016
 * @time 15:15
 */

namespace SicoCreditPlus\Models\OfferedOption;


use Shopware\Components\Model\ModelEntity;
use Doctrine\ORM\Mapping as ORM;
use SicoCreditPlus\Models\Productgroup\Productgroup;

/**
 * @ORM\Entity(repositoryClass="Repository")
 * @ORM\Table(name="sico_offered_option")
 */
class OfferedOption extends ModelEntity {

	/**
	 * @var int
	 * 
	 * @ORM\Column(name="id", type="integer", nullable=false)
	 * @ORM\Id
	 * @ORM\GeneratedValue(strategy="IDENTITY")
	 */
	private $id = NULL;
	/**
	 * @var int
	 * 
	 * @ORM\Column(name="sico_prodgroup", type="integer")
	 */
	private $sicoProdgroup = 0;
	/**
	 * @var int
	 * 
	 * @ORM\Column(name="sico_months", type="integer")
	 */
	private $sicoMonths = 0;
	/**
	 * @var float
	 * 
	 * @ORM\Column(name="sico_interest", type="float")
	 */
	private $sicoInterest = 0.00;
	/**
	 * @var string
	 * 
	 * @ORM\Column(name="sico_prodcode", type="string")
	 */
	private $sicoProdcode = '';
	/**
	 * @var boolean
	 * 
	 * @ORM\Column(name="sico_active", type="boolean")
	 */
	private $sicoActive = false;
	/**
	 * @var float
	 * 
	 * @ORM\Column(name="sico_ratefactor", type="float")
	 */
	private $sicoRatefactor = -1.00;

	/**
	 * @return int
	 */
	public function getId() {
		return $this->id;
	}

	/**
	 * @return int
	 */
	public function getSicoProdgroup() {
		return $this->sicoProdgroup;
	}

	/**
	 * @param int $sicoProdgroup
	 */
	public function setSicoProdgroup( $sicoProdgroup ) {
		$this->sicoProdgroup = $sicoProdgroup;
	}

	/**
	 * @return int
	 */
	public function getSicoMonths() {
		return $this->sicoMonths;
	}

	/**
	 * @param int $sicoMonths
	 */
	public function setSicoMonths( $sicoMonths ) {
		$this->sicoMonths = $sicoMonths;
	}

	/**
	 * @return float
	 */
	public function getSicoInterest() {
		return $this->sicoInterest;
	}

	/**
	 * @param float $sicoInterest
	 */
	public function setSicoInterest( $sicoInterest ) {
		$this->sicoInterest = $sicoInterest;
	}

	/**
	 * @return string
	 */
	public function getSicoProdcode() {
		return $this->sicoProdcode;
	}

	/**
	 * @param string $sicoProdcode
	 */
	public function setSicoProdcode( $sicoProdcode ) {
		$this->sicoProdcode = $sicoProdcode;
	}

	/**
	 * @return boolean
	 */
	public function getSicoActive() {
		return $this->sicoActive;
	}

	/**
	 * @param boolean $sicoActive
	 */
	public function setSicoActive( $sicoActive ) {
		$this->sicoActive = $sicoActive;
	}

	/**
	 * @return float
	 */
	public function getSicoRatefactor() {
		return $this->sicoRatefactor;
	}

	/**
	 * @param float $sicoRatefactor
	 */
	public function setSicoRatefactor( $sicoRatefactor ) {
		$this->sicoRatefactor = $sicoRatefactor;
	}

	/**
	 * OWNING SIDE
	 *
	 * @var Productgroup
	 *
	 * @ORM\ManyToOne(targetEntity="SicoCreditPlus\Models\Productgroup\Productgroup", inversedBy="offeredOptions")
	 * @ORM\JoinColumn(name="sico_prodgroup", referencedColumnName="id")
	 */
	private $productgroup = NULL;

	/**
	 * @return Productgroup
	 */
	public function getProductgroup() {
		return $this->productgroup;
	}

	/**
	 * @param Productgroup $productgroup
	 */
	public function setProductgroup( $productgroup ) {
		$this->productgroup = $productgroup;
	}

	private $name = NULL;

	/**
	 * @return null
	 */
	public function getName() {
		if ( $this->name ) {}
		return $this->sicoMonths.' zu '.number_format($this->sicoInterest,',','.').'%';
	}

	/**
	 * @param null $name
	 */
	public function setName( $name ) {
		$this->name = $name;
	}

}