<?php
/**
 * Created by PhpStorm.
 * @author mihovil.bubnjar
 * @date 09.08.2016
 * @time 15:33
 */

namespace SicoCreditPlus\Models\Productgroup;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use Shopware\Components\Model\ModelEntity;
use Shopware\Models\Article\Article;
use SicoCreditPlus\Models\OfferedOption\OfferedOption;

/**
 * @ORM\Entity(repositoryClass="Repository")
 * @ORM\Table(name="sico_productgroup")
 */
class Productgroup extends ModelEntity {
	/**
	 * @var int
	 *
	 * @ORM\Column(name="id", type="integer", nullable=false)
	 * @ORM\Id
	 * @ORM\GeneratedValue(strategy="IDENTITY")
	 */
	private $id = NULL;
	/**
	 * @var string
	 *
	 * @ORM\Column(name="sico_name", type="string")
	 */
	private $sicoName = '';
	/**
	 * @var string
	 *
	 * @ORM\Column(name="sico_product_type_id", type="string")
	 */
	private $sicoProductTypeId = '';
	/**
	 * @var string
	 *
	 * @ORM\Column(name="sico_product_class_id", type="string")
	 */
	private $sicoProductClassId = '';

	/**
	 * @return int
	 */
	public function getId() {
		return $this->id;
	}

	/**
	 * @return string
	 */
	public function getSicoName() {
		return $this->sicoName;
	}

	/**
	 * @param string $sicoName
	 */
	public function setSicoName( $sicoName ) {
		$this->sicoName = $sicoName;
	}

	/**
	 * @return string
	 */
	public function getSicoProductTypeId() {
		return $this->sicoProductTypeId;
	}

	/**
	 * @param string $sicoProductTypeId
	 */
	public function setSicoProductTypeId( $sicoProductTypeId ) {
		$this->sicoProductTypeId = $sicoProductTypeId;
	}

	/**
	 * @return string
	 */
	public function getSicoProductClassId() {
		return $this->sicoProductClassId;
	}

	/**
	 * @param string $sicoProductClassId
	 */
	public function setSicoProductClassId( $sicoProductClassId ) {
		$this->sicoProductClassId = $sicoProductClassId;
	}

	/**
	 * Constructor for this class
	 */
	public function __construct() {
		$this->offeredOptions = new ArrayCollection();
		$this->articles = new ArrayCollection();
	}

	/**
	 * PARTICIPATING SIDE
	 *
	 * @var \Doctrine\Common\Collections\ArrayCollection
	 *
	 * @ORM\OneToMany(targetEntity="SicoCreditPlus\Models\OfferedOption\OfferedOption", mappedBy="productgroup", cascade={"persist","remove"})
	 * @ORM\JoinColumn(name="id", referencedColumnName="sico_prodgroup")
	 */
	private $offeredOptions = NULL;

	/**
	 * @return ArrayCollection|OfferedOption[]
	 */
	public function getOfferedOptions() {
		return $this->offeredOptions;
	}

	/**
	 * @param ArrayCollection|OfferedOption[] $offeredOptions
	 * @return Productgroup
	 */
	public function setOfferedOptions( $offeredOptions ) {
		return $this->setOneToMany($offeredOptions, '\SicoCreditPlus\Models\OfferedOption\OfferedOption', 'offeredOptions', 'productgroup');
	}

	/**
	 * OWNING SIDE
	 *
	 * @var ArrayCollection|Article[]
	 *
	 * @ORM\ManyToMany(targetEntity="Shopware\Models\Article\Article")
	 * @ORM\JoinTable(name="sico_productgroup_s_articles",
	 *  joinColumns={@ORM\JoinColumn(name="productgroup_id", referencedColumnName="id")},
	 *  inverseJoinColumns={@ORM\JoinColumn(name="article_id", referencedColumnName="id")}
	 * )
	 */
	private $articles = NULL;

	/**
	 * @return ArrayCollection|Article[]
	 */
	public function getArticles() {
		return $this->articles;
	}

	/**
	 * @param ArrayCollection|Article[] $articles
	 */
	public function setArticles( $articles ) {
		$this->articles = $articles;
	}

	/**
	 * @var string
	 */
	private $name = '';
	/**
	 * Helper for Backend display
	 * @return string
	 */
	public function getName() {
		if ( $this->name ) {
			// just checking for code analysis :)
		}
		return $this->sicoName;
	}

	public function setName( $sName ) {
		$this->name = $sName;
	}
}