<?php
/**
 * Created by PhpStorm.
 * @author mihovil.bubnjar
 * @date 23.10.2018
 * @time 14:51
 */

namespace SicoCreditPlus\Models\RequestQueue;

use Doctrine\ORM\Mapping as ORM;
use Shopware\Components\Model\ModelEntity;
use Shopware\Models\Order\Order;

/**
 * @ORM\Entity(repositoryClass="Repository")
 * @ORM\Table(name="sico_request_queue")
 */
class RequestQueue extends ModelEntity {
	/**
	 * @var int
	 *
	 * @ORM\Column(name="id", type="integer", nullable=false)
	 * @ORM\Id
	 * @ORM\GeneratedValue(strategy="IDENTITY")
	 */
	private $id = NULL;
	/**
	 * @var \DateTime
	 *
	 * @ORM\Column(name="execution_date", type="datetime")
	 */
	private $executionDate = '';
	/**
	 * @var int
	 *
	 * @ORM\Column(name="retry_round", type="integer")
	 */
	private $retryRound = 0;
	/**
	 * @var int
	 *
	 * @ORM\Column(name="already_executed", type="integer")
	 */
	private $alreadyExecuted = 0;
	
	/**
	 * OWNING SIDE
	 *
	 * @var Order
	 *
	 * @ORM\ManyToOne(targetEntity="Shopware\Models\Order\Order")
	 * @ORM\JoinColumn(name="order_id", referencedColumnName="id")
	 */
	private $order = null;

	/**
	 * @return int
	 */
	public function getId() {
		return $this->id;
	}

	/**
	 * @return \DateTime
	 */
	public function getExecutionDate() {
		return $this->executionDate;
	}

	/**
	 * @param \DateTime $executionDate
	 *
	 * @return RequestQueue
	 */
	public function setExecutionDate( $executionDate ) {
		$this->executionDate = $executionDate;

		return $this;
	}

	/**
	 * @return int
	 */
	public function getRetryRound() {
		return $this->retryRound;
	}

	/**
	 * @param int $retryRound
	 *
	 * @return RequestQueue
	 */
	public function setRetryRound( $retryRound ) {
		$this->retryRound = $retryRound;

		return $this;
	}

	/**
	 * @return int
	 */
	public function getAlreadyExecuted() {
		return $this->alreadyExecuted;
	}

	/**
	 * @param int $alreadyExecuted
	 * 
	 * @return RequestQueue
	 */
	public function setAlreadyExecuted( $alreadyExecuted ) {
		$this->alreadyExecuted = $alreadyExecuted;
		
		return $this;
	}

	/**
	 * @return Order
	 */
	public function getOrder() {
		return $this->order;
	}

	/**
	 * @param Order $order
	 *
	 * @return RequestQueue
	 */
	public function setOrder( $order ) {
		$this->order = $order;

		return $this;
	}
	
	
}