/**
 * Created by mihovil.bubnjar on 25.08.2016.
 */

/**
 * Shopware 5
 * Copyright (c) shopware AG
 *
 * According to our dual licensing model, this program can be used either
 * under the terms of the GNU Affero General Public License, version 3,
 * or under a proprietary license.
 *
 * The texts of the GNU Affero General Public License with an additional
 * permission and of our proprietary license can be found at and
 * in the LICENSE file you have received along with this program.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * "Shopware" is a registered trademark of shopware AG.
 * The licensing of the program under the AGPLv3 does not imply a
 * trademark license. Therefore any rights, title and interest in
 * our trademarks remain entirely with us.
 *
 * @category   Shopware
 * @package    Order
 * @subpackage Model
 * @version    $Id$
 * @author SinkaCom AG
 */

/**
 * SinkaCom Model - Order additional data.
 *
 */
//{block name="backend/order/model/order" append}

Ext.define('Shopware.apps.Order.model.SicoOrder', {
	override: 'Shopware.apps.Order.model.Order',

	constructor: function() {
		var me = this;
		me.callParent(arguments);
		me.associations.add(Ext.data.Association.create({
			associatedModel: 'Shopware.apps.Order.model.SicoCreditPlusData',
			associationKey: 'sicoCreditPlusData',
			model: 'Shopware.apps.Order.model.SicoCreditPlusData',
			name: 'getSicoCreditPlusData',
			ownerModel: 'Shopware.apps.Order.model.Order',
			storeName: 'getSicoCreditPlusDataStore',
			instanceName: 'getSicoCreditPlusDataStore',
			type: 'hasOne'
		}));
	},

	getSicoCreditPlusData: function() {
		var ds = this.getSicoCreditPlusDataStore;
		if ( ds && ds.raw.customer && ds.raw.contract ) {
			return ds;
		}
		return null;
	}
});

//{/block}