/**
 * Created by mihovil.bubnjar on 08.09.2016.
 */
/* {namespace name="frontend/plugins/payment/creditplus/backend"} */
//{block name="backend/order/view/batch/form" append}
Ext.define('Shopware.apps.Order.view.batch.SicoForm', {
	override: 'Shopware.apps.Order.view.batch.Form',
	
	createSettingsContainer: function() {
		var me = this,
			oReturn = me.callParent(arguments);
		if ( oReturn && me.hasSicoCreditPlusFinancingOrders() ) {
			Ext.each(oReturn.items.items, function(oElement) {
				if ( (oElement.name == 'orderStatus')
					|| (oElement.name == 'paymentStatus')
				) {
					oElement.disabled = true;
				}
			});
			oReturn.add({
				'xtype': 'label',
				'html': '{s name="SicoCreditPlusDetected"}<p>In den Bestellungen befindet sich eine CreditPlus Bestellung. Einige Elemente sind daher deaktiviert.</p>{/s}'
			});
		}
		return oReturn;
	},

	/**
	 * Wenn einer der Einträge "sccp_financing" 
	 * als Zahlungsart hat, dann kommt true zurück.
	 *  
	 * @returns { boolean }
	 */
	hasSicoCreditPlusFinancingOrders: function() {
		var me = this,
			bSicoFinanced = false;
		Ext.each(me.records, function(oElement) {
			var oPayment = oElement.getPayment();
			if ( oPayment && oPayment.first() && (oPayment.first().get('name') == 'sccp_financing') ) {
				bSicoFinanced = true;
			}
		});
		
		return bSicoFinanced;
	}
});
//{/block}