/* {namespace name="frontend/plugins/payment/creditplus/backend"} */
/**
 * Created by mihovil.bubnjar on 05.09.2016.
 */

//{block name="backend/order/view/detail/overview" append}
Ext.define('Shopware.apps.Order.view.detail.SicoOverview', {
	override: 'Shopware.apps.Order.view.detail.Overview',
	/**
	 * Im Fall, dass es nicht die Zahlungsart sccp_finanzierung ist,
	 * wird einfach das Standard Ergebnis ausgegeben.
	 * 
	 * Wenn die Bezahlung mit CreditPlus gemacht wurde,
	 * dann werden die gefährlichen Input und Select Boxen deaktiviert.
	 * 
	 * @returns Object[] Array mit Objekten, welche durch ExtJS zu Inputboxen und Selectboxen umgebaut werden
	 */
	createEditElements: function() {
		var me = this,
			aReturn = me.callParent(arguments),
			oElement, sElementName;
		if ( me.record.getPayment() && me.record.getPayment().first() && me.record.getPayment().first().get('name') != 'sccp_financing' ) {
			return aReturn;
		}
		for ( var i in aReturn ) {
			if ( aReturn.hasOwnProperty(i) ) {
				oElement = aReturn[i];
				if (oElement.hasOwnProperty('name') ) {
					sElementName = oElement.name;
					switch ( sElementName ) {
						case 'invoiceShipping':
						case 'invoiceShippingNet':
						case 'status':
						case 'cleared':
							aReturn[i].disabled = true;
							break;
						default:
							// Nothing should happen
					}
				}
			}
		}
		return aReturn;
	}
});
//{/block}