/* {namespace name="frontend/plugins/payment/creditplus/backend"} */
//{block name="backend/order/view/detail/position" append}
Ext.define('Shopware.apps.Order.view.detail.SicoPosition', {
	override: 'Shopware.apps.Order.view.detail.Position',

	initComponent: function() {
		var me = this;
		me.callParent(arguments);
		me.on('savePosition', function(editor, e) {
			var oOrigValues = e.originalValues,
				oNewValues = e.newValues,
				dOldTotal = oOrigValues.price * oOrigValues.quantity,
				dNewTotal = oNewValues.price * oNewValues.quantity,
				sicoCPStatus;
			// Only lock our payment type orders
			if ( me.record.getPayment() && me.record.getPayment().first() && (me.record.getPayment().first().get('name') == 'sccp_financing') ) {
				if (
					me.record.getSicoCreditPlusData() && 
					me.record.getSicoCreditPlusData().getContract()) {
					sicoCPStatus = me.record.getSicoCreditPlusData().getContract().get('state');
				}

				// Declined and cancelled may not be edited any more.
				if ( me.isBlockedFromEdit(sicoCPStatus) || (dOldTotal < dNewTotal) ) {
					oNewValues.quantity = oOrigValues.quantity;
					oNewValues.price = oOrigValues.price;
					e.record.data.quantity = oOrigValues.quantity;
					e.record.data.price = oOrigValues.price;
				}

				if ( me.isBlockedFromEdit(sicoCPStatus) ) {
					Shopware.Notification.createGrowlMessage('{s name="SicoCreditPlusPositionWrongStateTitle"}Bearbeitungsfehler{/s}', '{s name="SicoCreditPlusPositionWrongStateMessage"}Die Bestellung darf in ihrem Zustand nicht mehr bearbeitet werden. Die Werte wurden auf die Ausgangswerte zurückgesetzt.{/s}', 'SicoCreditPlus');
				} else if ( dOldTotal < dNewTotal ) {
					Shopware.Notification.createGrowlMessage('{s name="SicoCreditPlusPositionErrorTitle"}Bearbeitungsfehler{/s}', '{s name="SicoCreditPlusPositionErrorMessage"}Die eingegeben Werte dürfen den Preis nicht erhöhen. Sie wurden entsprechend auf die Ausgangswerte gesetzt.{/s}', 'SicoCreditPlus');
				}
			}
		});
	},

	isBlockedFromEdit: function(sicoCPStatus) {
		return (
			(sicoCPStatus == '95')
			|| (sicoCPStatus == '93')
			|| (sicoCPStatus == '92')
		);
	},
	/**
	 * Creates the toolbar for the position grid.
	 * @return Ext.toolbar.Toolbar
	 */
	createGridToolbar: function() {
		var me = this,
			oReturn = me.callParent(arguments);
		if ( me.record.getPayment() && me.record.getPayment().first() && (me.record.getPayment().first().get('name') == 'sccp_financing') ) {
			me.addPositionButton.disabled = true;
		}
		return oReturn;
	}
});
//{/block}