/**
 * Created by Mihovil.Bubnjar on 18.08.2016.
 */
// {namespace name="frontend/plugins/payment/creditplus/backend"}
Ext.define('Shopware.apps.SicoCreditPlusOfferedOptions.view.detail.SicoCreditPlusOfferedOption', {
	extend: 'Shopware.model.Container',
	padding: 20,

	snippets: {
		sicoRatefactorInvalid: '{s name="SicoOfferedOptionFieldSicoRatefactorInvalid"}Wählen Sie einen Wert der zwischen 0,00 und 1,00 liegt oder -1,00 für automatische Berechnung.{/s}',
		sicoInterestInvalid: '{s name="SicoOfferedOptionFieldSicoInterestInvalid"}Wählen Sie einen Wert zwischen 0 und 14,99.{/s}'
	},
	
	configure: function() {
		var me = this;
		return {
			controller: 'SicoCreditPlusOfferedOptions',
			fieldSets: [
				{
					title: '{s name="SicoOfferedOptionWindowTitle"}Zinstabelle Eintrag{/s}',
					fields: {
						sicoMonths: {
							fieldLabel: '{s name="SicoOfferedOptionFieldSicoMonths"}Monate{/s}',
							allowBlank: false // field required
						},
						sicoInterest: {
							fieldLabel: '{s name="SicoOfferedOptionFieldSicoInterest"}Effektiver Jahreszins{/s}',
							allowBlank: false, // field required
							minValue: 0.00,
							maxValue: 14.99,
							decimalPrecision: 2,
							submitLocaleSeparator: false,
							step: 0.01,
							invalidText: me.snippets.sicoInterestInvalid
						},
						sicoProdcode: {
							fieldLabel: '{s name="SicoOfferedOptionFieldSicoProdcode"}Produkt Code{/s}',
							allowBlank: false // field required
						},
						sicoActive: {
							fieldLabel: '{s name="SicoOfferedOptionFieldSicoActive"}Aktiv{/s}'
						},
						sicoRatefactor: {
							fieldLabel: '{s name="SicoOfferedOptionFieldSicoRatefactor"}Ratenfaktor{/s}',
							allowBlank: false, // field required
							minValue: -1.000000000,
							maxValue: 0.999999999,
							decimalPrecision: 9,
							submitLocaleSeparator: false,
							step: 0.001,
							validator: function(v) {
								if ( !Ext.isNumeric(v) && /[0-9-,]+/.test(v) ) {
									v = v.replace(',','.');
								}
								if ( !Ext.isNumeric(v) ) {
									return me.snippets.sicoRatefactorInvalid;
								}
								v = parseFloat(v);
								if ( v == -1.00 ) {
									return true;
								}
								if ( v <= 0.00 ) {
									return me.snippets.sicoRatefactorInvalid;
								}
								if ( v >= 1.00 ) {
									return me.snippets.sicoRatefactorInvalid;
								}
								return true;
							}
						},
						 sicoProdgroup: {
							fieldLabel: '{s name="SicoOfferedOptionFieldSicoProductgroup"}Produktgruppe{/s}',
							validator: function ( value ) {
								if ( value == 0 ) {
									return '{s name="SicoOfferedOptionErrorSicoProductgroupEmpty"}Bitte wählen Sie eine Produktgruppe{/s}';
								} else {
									return true;
								}
							},
							editable: false,
							allowBlank: false,
							forceSelection: true
						}
					}
				}
			]
		};
	}
});