/**
 * Shopware 5
 * Copyright (c) SinkaCom AG
 *
 * According to our dual licensing model, this program can be used either
 * under the terms of the GNU Affero General Public License, version 3,
 * or under a proprietary license.
 *
 * The texts of the GNU Affero General Public License with an additional
 * permission and of our proprietary license can be found at and
 * in the LICENSE file you have received along with this program.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * "Shopware" is a registered trademark of shopware AG.
 * The licensing of the program under the AGPLv3 does not imply a
 * trademark license. Therefore any rights, title and interest in
 * our trademarks remain entirely with us.
 */

/**
 * SinkaCom Productgroups Module - Unassigned articles store
 *
 * @category  Shopware
 * @copyright Copyright (c) SinkaCom AG (http://www.sinkacom.de)
 */
//{namespace name="frontend/plugins/payment/creditplus/backend"}
//{block name="backend/sico_credit_plus_productgroups/store/unassigned_articles"}
Ext.define('Shopware.apps.SicoCreditPlusProductgroups.store.UnassignedArticles', {

	/**
	 * Extend for the standard ExtJS 4
	 * @string
	 */
	extend: 'Ext.data.Store',

	/**
	 * Truthy to filter on the server side, otherwise falsy to filter on the client side.
	 * @boolean
	 */
	remoteFilter: true,

	/**
	 * Auto load the store after the component
	 * is initialized
	 * @boolean
	 */
	autoLoad : false,

	/**
	 * Define the used model for this store
	 * @string
	 */
	model : 'Shopware.apps.SicoCreditPlusProductgroups.model.AssignedArticle',

	/**
	 * Batch size
	 * @integer
	 */
	pageSize: 20,

	/**
	 * Configure the data communication
	 * @object
	 */
	proxy: {
		type: 'ajax',

		/**
		 * Configure the url mapping for the different
		 * store operations based on
		 * @object
		 */
		url: '{url controller="SicoCreditPlusProductgroups" action="getUnassignedArticles"}',

		/**
		 * Configure the data reader
		 * @object
		 */
		reader: {
			type: 'json',
			root: 'data',
			totalProperty: 'total'
		}
	}
});
//{/block}
