/**
 * Created by Mihovil.Bubnjar on 18.08.2016.
 */
// {namespace name="frontend/plugins/payment/creditplus/backend"}
Ext.define('Shopware.apps.SicoCreditPlusProductgroups.view.detail.Window', {
	extend: 'Shopware.window.Detail',
	alias: 'widget.sicoproductgroup-detail-window',
	title : '{s name="SicoProductgroupWindowTitle"}Produktgruppe{/s}',
	height: 620,
	width: 900,

	/**
	 * Contains all snippets for the component
	 * @object
	 */
	snippets: {
		articlesTab: '{s name="SicoProductgroupTabTitleArticles"}Zugewiesene Artikel{/s}',
		mainTab: '{s name="SicoProductgroupTabTitleMain"}Produktgruppe{/s}'
	},

	initComponent: function () {
		var me = this;
		me.callParent(arguments);
	},

	createTabItems: function () {
		var me = this;
		return [
			me.createBaseTab(),
			me.createArticlesTab()
		];
	},

	createMainTabPanel: function() {
		var me = this;
		me.mainTab = Ext.create('Ext.tab.Panel', {
			name: 'main-tab-panel',
			items: [
				me.createBaseTab(),
				me.createArticlesTab()
			]
		});
		return me.mainTab;
	},

	createArticlesTab: function() {
		var me = this;

		me.availableProductsStore = Ext.create('Shopware.apps.SicoCreditPlusProductgroups.store.UnassignedArticles');
		me.assignedProductsStore = Ext.create('Shopware.apps.SicoCreditPlusProductgroups.store.AssignedArticles');

		me.availableProductsStore.getProxy().extraParams.id = me.record.get('id');
		me.assignedProductsStore.getProxy().extraParams.id = me.record.get('id');

		me.articlesTab = Ext.create('Ext.container.Container', {
			title: me.snippets.articlesTab,
			disabled: false,
			layout: 'fit',
			items: [
				Ext.create('Shopware.apps.SicoCreditPlusProductgroups.view.detail.ArticleAssignment', {
					record: me.record,
					availableProductsStore: me.availableProductsStore,
					assignedProductsStore: me.assignedProductsStore
				})
			],
			name: 'articles'
		});
		return me.articlesTab;
	},

	/**
	 * Creates the base field set for the detail form.
	 * @return { Shopware.apps.SicoCreditPlusProductgroups.view.detail.OfferedOptions }
	 */
	createOfferedOptionsFieldSet: function() {
		var me = this;
		return Ext.create('Shopware.apps.SicoCreditPlusProductgroups.view.detail.OfferedOptions', {
			record: me.record
		});
	},

	/**
	 * Creates the base field set for the detail form.
	 * @return { Shopware.apps.SicoCreditPlusProductgroups.view.detail.Base }
	 */
	createBaseFieldSet: function() {
		var me = this;
		return Ext.create('Shopware.apps.SicoCreditPlusProductgroups.view.detail.Base', {
			record: me.record
		});
	},

	/**
	 * Creates the tab panel for the base data. Contains a form panel which allows the user
	 * to edit the selected record
	 * @return Ext.container.Container
	 */
	createBaseTab: function() {
		var me = this;

		me.detailForm = Ext.create('Ext.form.Panel', {
			region: 'center',
			name: 'detail-form',
			bodyPadding: 10,
			autoScroll: true,
			defaults: {
				labelWidth: 155
			},
			items: [
				me.createBaseFieldSet(),
				me.createOfferedOptionsFieldSet()
			]
		});

		return me.detailContainer = Ext.create('Ext.container.Container', {
			layout: 'fit',
			name: 'main',
			title: me.snippets.mainTab,
			items: [
				me.detailForm
			]
		});
	}
});